Index: /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/OCE/DYN/dynkeg.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/OCE/DYN/dynkeg.F90	(revision 11081)
+++ /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/OCE/DYN/dynkeg.F90	(revision 11082)
@@ -74,10 +74,10 @@
       INTEGER, INTENT( in ) ::   kscheme   ! =0/1   type of KEG scheme 
       !
-      INTEGER  ::   ji, jj, jk, jb    ! dummy loop indices
-      INTEGER  ::   ii, ifu, ib_bdy   ! local integers
-      INTEGER  ::   ij, ifv, igrd     !   -       -
-      REAL(wp) ::   zu, zv            ! local scalars
+      INTEGER  ::   ji, jj, jk, jb           ! dummy loop indices
+      INTEGER  ::   ifu, ifv, igrd, ib_bdy   ! local integers
+      REAL(wp) ::   zu, zv                   ! local scalars
       REAL(wp), DIMENSION(jpi,jpj,jpk)        ::   zhke
       REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   ztrdu, ztrdv 
+      REAL(wp)  :: zweightu, zweightv
       !!----------------------------------------------------------------------
       !
@@ -97,32 +97,4 @@
       
       zhke(:,:,jpk) = 0._wp
-      
-      IF (ln_bdy) THEN
-         ! Maria Luneva & Fred Wobus: July-2016
-         ! compensate for lack of turbulent kinetic energy on liquid bdy points
-         DO ib_bdy = 1, nb_bdy
-            IF( cn_dyn3d(ib_bdy) /= 'none' ) THEN
-               igrd = 2           ! Copying normal velocity into points outside bdy
-               DO jb = 1, idx_bdy(ib_bdy)%nblenrim(igrd)
-                  DO jk = 1, jpkm1
-                     ii   = idx_bdy(ib_bdy)%nbi(jb,igrd)
-                     ij   = idx_bdy(ib_bdy)%nbj(jb,igrd)
-                     ifu   = NINT( idx_bdy(ib_bdy)%flagu(jb,igrd) )
-                     un(ii-ifu,ij,jk) = un(ii,ij,jk) * umask(ii,ij,jk)
-                  END DO
-               END DO
-               !
-               igrd = 3           ! Copying normal velocity into points outside bdy
-               DO jb = 1, idx_bdy(ib_bdy)%nblenrim(igrd)
-                  DO jk = 1, jpkm1
-                     ii   = idx_bdy(ib_bdy)%nbi(jb,igrd)
-                     ij   = idx_bdy(ib_bdy)%nbj(jb,igrd)
-                     ifv   = NINT( idx_bdy(ib_bdy)%flagv(jb,igrd) )
-                     vn(ii,ij-ifv,jk) = vn(ii,ij,jk) * vmask(ii,ij,jk)
-                  END DO
-               END DO
-            ENDIF
-         ENDDO  
-      ENDIF 
 
       SELECT CASE ( kscheme )             !== Horizontal kinetic energy at T-point  ==!
@@ -140,4 +112,28 @@
             END DO
          END DO
+         !
+         IF (ln_bdy) THEN
+            ! Maria Luneva & Fred Wobus: July-2016
+            ! compensate for lack of turbulent kinetic energy on liquid bdy points
+            DO ib_bdy = 1, nb_bdy
+               IF( cn_dyn3d(ib_bdy) /= 'none' ) THEN
+                  igrd = 1           ! compensating null velocity on the bdy
+                  DO jb = 1, idx_bdy(ib_bdy)%nblenrim(igrd)
+                     ji   = idx_bdy(ib_bdy)%nbi(jb,igrd)   ! maximum extent : from 2 to jpi-1
+                     jj   = idx_bdy(ib_bdy)%nbj(jb,igrd)   ! maximum extent : from 2 to jpj-1
+                     DO jk = 1, jpkm1
+                        zhke(ji,jj,jk) = 0._wp
+                        zweightu = umask(ji-1,jj  ,jk) + umask(ji,jj,jk)
+                        zweightv = vmask(ji  ,jj-1,jk) + vmask(ji,jj,jk)
+                        zu = un(ji-1,jj  ,jk) * un(ji-1,jj  ,jk)  +  un(ji  ,jj  ,jk) * un(ji  ,jj  ,jk)
+                        zv = vn(ji  ,jj-1,jk) * vn(ji  ,jj-1,jk)  +  vn(ji  ,jj  ,jk) * vn(ji  ,jj  ,jk)
+                        IF( zweightu > 0._wp )   zhke(ji,jj,jk) =  zhke(ji,jj,jk) + zu / (2._wp * zweightu) 
+                        IF( zweightv > 0._wp )   zhke(ji,jj,jk) =  zhke(ji,jj,jk) + zv / (2._wp * zweightv) 
+                     END DO
+                  END DO
+               END IF
+               CALL lbc_bdy_lnk( 'dynkeg', zhke, 'T', 1., ib_bdy )   ! send 2 and recv jpi, jpj used in the computation of the speed tendencies
+            END DO
+         END IF
          !
       CASE ( nkeg_HW )                          !--  Hollingsworth scheme  --!
@@ -158,14 +154,37 @@
             END DO
          END DO
+         IF (ln_bdy) THEN
+            ! Maria Luneva & Fred Wobus: July-2016
+            ! compensate for lack of turbulent kinetic energy on liquid bdy points
+            DO ib_bdy = 1, nb_bdy
+               IF( cn_dyn3d(ib_bdy) /= 'none' ) THEN
+                  igrd = 1           ! compensation null velocity on land at the bdy
+                  DO jb = 1, idx_bdy(ib_bdy)%nblenrim(igrd)
+                     ji   = idx_bdy(ib_bdy)%nbi(jb,igrd)   ! maximum extent : from 2 to jpi-1
+                     jj   = idx_bdy(ib_bdy)%nbj(jb,igrd)   ! maximum extent : from 2 to jpj-1
+                     DO jk = 1, jpkm1
+                        zhke(ji,jj,jk) = 0._wp
+                        zweightu = 8._wp * ( umask(ji-1,jj  ,jk) + umask(ji  ,jj  ,jk) ) &
+                             &   + 2._wp * ( umask(ji-1,jj-1,jk) + umask(ji-1,jj+1,jk) + umask(ji  ,jj-1,jk) + umask(ji  ,jj+1,jk) ) 
+                        zweightv = 8._wp * ( vmask(ji  ,jj-1,jk) + vmask(ji  ,jj-1,jk) ) &
+                             &   + 2._wp * ( vmask(ji-1,jj-1,jk) + vmask(ji+1,jj-1,jk) + vmask(ji-1,jj  ,jk) + vmask(ji+1,jj  ,jk) )
+                        zu = 8._wp * ( un(ji-1,jj  ,jk) * un(ji-1,jj  ,jk)    &
+                           &         + un(ji  ,jj  ,jk) * un(ji  ,jj  ,jk) )  &
+                           &   +     ( un(ji-1,jj-1,jk) + un(ji-1,jj+1,jk) ) * ( un(ji-1,jj-1,jk) + un(ji-1,jj+1,jk) )   &
+                           &   +     ( un(ji  ,jj-1,jk) + un(ji  ,jj+1,jk) ) * ( un(ji  ,jj-1,jk) + un(ji  ,jj+1,jk) )
+                        zv = 8._wp * ( vn(ji  ,jj-1,jk) * vn(ji  ,jj-1,jk)    &
+                           &         + vn(ji  ,jj  ,jk) * vn(ji  ,jj  ,jk) )  &
+                           &  +      ( vn(ji-1,jj-1,jk) + vn(ji+1,jj-1,jk) ) * ( vn(ji-1,jj-1,jk) + vn(ji+1,jj-1,jk) )   &
+                           &  +      ( vn(ji-1,jj  ,jk) + vn(ji+1,jj  ,jk) ) * ( vn(ji-1,jj  ,jk) + vn(ji+1,jj  ,jk) )
+                        IF( zweightu > 0._wp )   zhke(ji,jj,jk) =  zhke(ji,jj,jk) +  zu / ( 2._wp * zweightu )
+                        IF( zweightv > 0._wp )   zhke(ji,jj,jk) =  zhke(ji,jj,jk) +  zv / ( 2._wp * zweightv )
+                     END DO
+                  END DO
+               END IF
+            END DO
+         END IF
          CALL lbc_lnk( 'dynkeg', zhke, 'T', 1. )
          !
-      END SELECT
-
-      IF (ln_bdy) THEN
-         ! restore velocity masks at points outside boundary
-         un(:,:,:) = un(:,:,:) * umask(:,:,:)
-         vn(:,:,:) = vn(:,:,:) * vmask(:,:,:)
-      ENDIF      
-
+      END SELECT 
       !
       DO jk = 1, jpkm1                    !==  grad( KE ) added to the general momentum trends  ==!
Index: /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/OCE/DYN/sshwzv.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/OCE/DYN/sshwzv.F90	(revision 11081)
+++ /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/OCE/DYN/sshwzv.F90	(revision 11082)
@@ -297,7 +297,6 @@
          IF(lwp) WRITE(numout,*) 'wAimp : Courant number-based partitioning of now vertical velocity '
          IF(lwp) WRITE(numout,*) '~~~~~ '
-         !
-         Cu_adv(:,:,jpk) = 0._wp              ! bottom value : Cu_adv=0 (set once for all)
-      ENDIF
+      ENDIF
+      !
       !
       DO jk = 1, jpkm1            ! calculate Courant numbers
@@ -305,27 +304,27 @@
             DO ji = 2, fs_jpim1   ! vector opt.
                z1_e3w = 1._wp / e3w_n(ji,jj,jk)
-               Cu_adv(ji,jj,jk) = r2dt * ( ( MAX( wn(ji,jj,jk) , 0._wp ) - MIN( wn(ji,jj,jk+1) , 0._wp ) )    &
-                  &                      + ( MAX( e2u(ji  ,jj)*e3uw_n(ji  ,jj,jk)*un(ji  ,jj,jk), 0._wp ) -   &
-                  &                          MIN( e2u(ji-1,jj)*e3uw_n(ji-1,jj,jk)*un(ji-1,jj,jk), 0._wp ) )   &
-                  &                        * r1_e1e2t(ji,jj)                                                  &
-                  &                      + ( MAX( e1v(ji,jj  )*e3vw_n(ji,jj  ,jk)*vn(ji,jj  ,jk), 0._wp ) -   &
-                  &                          MIN( e1v(ji,jj-1)*e3vw_n(ji,jj-1,jk)*vn(ji,jj-1,jk), 0._wp ) )   &
-                  &                        * r1_e1e2t(ji,jj)                                                  &
-                  &                      ) * z1_e3w
+               Cu_adv(ji,jj,jk) = 2._wp * rdt * ( ( MAX( wn(ji,jj,jk) , 0._wp ) - MIN( wn(ji,jj,jk+1) , 0._wp ) )    &  ! 2*rdt and not r2dt (for restartability)
+                  &                             + ( MAX( e2u(ji  ,jj)*e3uw_n(ji  ,jj,jk)*un(ji  ,jj,jk), 0._wp ) -   &
+                  &                                 MIN( e2u(ji-1,jj)*e3uw_n(ji-1,jj,jk)*un(ji-1,jj,jk), 0._wp ) )   &
+                  &                               * r1_e1e2t(ji,jj)                                                  &
+                  &                             + ( MAX( e1v(ji,jj  )*e3vw_n(ji,jj  ,jk)*vn(ji,jj  ,jk), 0._wp ) -   &
+                  &                                 MIN( e1v(ji,jj-1)*e3vw_n(ji,jj-1,jk)*vn(ji,jj-1,jk), 0._wp ) )   &
+                  &                               * r1_e1e2t(ji,jj)                                                  &
+                  &                             ) * z1_e3w
             END DO
          END DO
       END DO
+      CALL lbc_lnk( 'sshwzv', Cu_adv, 'T', 1. )
       !
       CALL iom_put("Courant",Cu_adv)
       !
-      wi(:,:,:) = 0._wp                                 ! Includes top and bottom values set to zero
       IF( MAXVAL( Cu_adv(:,:,:) ) > Cu_min ) THEN       ! Quick check if any breaches anywhere
          DO jk = 1, jpkm1                               ! or scan Courant criterion and partition
-            DO jj = 2, jpjm1                            ! w where necessary
-               DO ji = 2, fs_jpim1   ! vector opt.
+            DO jj = 1, jpj                              ! w where necessary
+               DO ji = 1, jpi
                   !
                   zCu = MAX( Cu_adv(ji,jj,jk) , Cu_adv(ji,jj,jk+1) )
                   !
-                  IF( zCu < Cu_min ) THEN               !<-- Fully explicit
+                  IF( zCu <= Cu_min ) THEN              !<-- Fully explicit
                      zcff = 0._wp
                   ELSEIF( zCu < Cu_cut ) THEN           !<-- Mixed explicit
@@ -346,5 +345,6 @@
       ELSE
          ! Fully explicit everywhere
-         Cu_adv = 0.0_wp                                ! Reuse array to output coefficient
+         Cu_adv(:,:,:) = 0._wp                          ! Reuse array to output coefficient
+         wi    (:,:,:) = 0._wp
       ENDIF
       CALL iom_put("wimp",wi) 
Index: /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/OCE/LBC/lib_mpp.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/OCE/LBC/lib_mpp.F90	(revision 11081)
+++ /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/OCE/LBC/lib_mpp.F90	(revision 11082)
@@ -1480,6 +1480,7 @@
       LOGICAL         , OPTIONAL, INTENT(in   ) ::   ld_lbc, ld_glb, ld_dlg
       !!
+      CHARACTER(len=128)                        ::   ccountname  ! name of a subroutine to count communications
       LOGICAL ::   ll_lbc, ll_glb, ll_dlg
-      INTEGER ::    ji,  jj,  jk,  jh, jf   ! dummy loop indices
+      INTEGER ::    ji,  jj,  jk,  jh, jf, jcount   ! dummy loop indices
       !!----------------------------------------------------------------------
       !
@@ -1538,13 +1539,21 @@
          WRITE(numcom,*) ' '
          WRITE(numcom,*) ' lbc_lnk called'
-         jj = 1
-         DO ji = 2, n_sequence_lbc
-            IF( crname_lbc(ji-1) /= crname_lbc(ji) ) THEN
-               WRITE(numcom,'(A, I4, A, A)') ' - ', jj,' times by subroutine ', TRIM(crname_lbc(ji-1))
-               jj = 0
+         DO ji = 1, n_sequence_lbc - 1
+            IF ( crname_lbc(ji) /= 'already counted' ) THEN
+               ccountname = crname_lbc(ji)
+               crname_lbc(ji) = 'already counted'
+               jcount = 1
+               DO jj = ji + 1, n_sequence_lbc
+                  IF ( ccountname ==  crname_lbc(jj) ) THEN
+                     jcount = jcount + 1
+                     crname_lbc(jj) = 'already counted'
+                  END IF
+               END DO
+               WRITE(numcom,'(A, I4, A, A)') ' - ', jcount,' times by subroutine ', TRIM(ccountname)
             END IF
-            jj = jj + 1 
          END DO
-         WRITE(numcom,'(A, I4, A, A)') ' - ', jj,' times by subroutine ', TRIM(crname_lbc(n_sequence_lbc))
+         IF ( crname_lbc(n_sequence_lbc) /= 'already counted' ) THEN
+            WRITE(numcom,'(A, I4, A, A)') ' - ', 1,' times by subroutine ', TRIM(crname_lbc(ncom_rec_max))
+         END IF
          WRITE(numcom,*) ' '
          IF ( n_sequence_glb > 0 ) THEN
Index: /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/OCE/ZDF/zdfphy.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/OCE/ZDF/zdfphy.F90	(revision 11081)
+++ /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/OCE/ZDF/zdfphy.F90	(revision 11082)
@@ -132,6 +132,7 @@
       IF( ln_zad_Aimp ) THEN
          IF( zdf_phy_alloc() /= 0 )   &
-        &       CALL ctl_stop( 'STOP', 'zdf_phy_init : unable to allocate adaptive-implicit z-advection arrays' )
-         wi(:,:,:) = 0._wp
+            &       CALL ctl_stop( 'STOP', 'zdf_phy_init : unable to allocate adaptive-implicit z-advection arrays' )
+         Cu_adv(:,:,:) = 0._wp
+         wi    (:,:,:) = 0._wp
       ENDIF
       !                          !==  Background eddy viscosity and diffusivity  ==!
Index: /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/TOP/PISCES/P4Z/p4zpoc.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/TOP/PISCES/P4Z/p4zpoc.F90	(revision 11081)
+++ /NEMO/branches/UKMO/NEMO_4.0_GO8_package/src/TOP/PISCES/P4Z/p4zpoc.F90	(revision 11082)
@@ -166,5 +166,5 @@
                        &   + zsizek1 ) ) * zpoc + ( prodgoc(ji,jj,jk-1) / tgfunc(ji,jj,jk-1) * ( 1.           &
                        &   - exp( -reminp(jn) * zsizek1 ) ) * exp( -reminp(jn) * zsizek ) + prodgoc(ji,jj,jk) &
-                       &   / tgfunc(ji,jj,jk) * ( 1. - exp( -reminp(jn) * zsizek ) ) ) * rday / rfact2 / reminp(jn) 
+                       &   / tgfunc(ji,jj,jk) * ( 1. - exp( -reminp(jn) * zsizek ) ) ) * rday / rfact2 / reminp(jn) * alphan(jn) 
                        alphat = alphat + alphag(ji,jj,jk,jn)
                        remint = remint + alphag(ji,jj,jk,jn) * reminp(jn)
Index: /NEMO/branches/UKMO/NEMO_4.0_GO8_package/tests/OVERFLOW/MY_SRC/usrdef_zgr.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0_GO8_package/tests/OVERFLOW/MY_SRC/usrdef_zgr.F90	(revision 11081)
+++ /NEMO/branches/UKMO/NEMO_4.0_GO8_package/tests/OVERFLOW/MY_SRC/usrdef_zgr.F90	(revision 11082)
@@ -96,8 +96,8 @@
       !                                ! ==>>>  set by hand non-zero value on first/last columns & rows 
       DO ji = mi0(1), mi1(1)              ! first row of global domain only
-         zhu(ji,2) = zht(1,2)
-      END DO
-       DO ji = mi0(jpi), mi1(jpi)         ! last  row of global domain only
-         zhu(ji,2) = zht(jpi,2)
+         zhu(ji,2) = zht(ji,2)
+      END DO
+       DO ji = mi0(jpiglo), mi1(jpiglo)   ! last  row of global domain only
+         zhu(ji,2) = zht(ji,2)
       END DO
       zhu(:,1) = zhu(:,2)
